/* Copyright (c) Patronsoft Limited. All rights reserved. */

#include "StdAfx.h"
#include "IASPL.h"

// see IASPL.h for the class definition
CPrintLog::CPrintLog()
{
	SYSTEMTIME	st;							// system time

	// get local time
	GetLocalTime(&st);

	configExist = ReadINI();
	ZeroMemory( logFile, _MAX_FNAME );
	if( (strlen(fname)+strlen("\\FSPlugIn.log")+strlen("00_00_0000")+1)<=_MAX_FNAME )
	{
		sprintf( logFile, "%s\\fsIASdll%02d_%02d_%4d.log", fname, st.wDay, st.wMonth,
			st.wYear );
	}
	else {
		sprintf( logFile, "fsIASdll%02d_%02d_%4d.log", st.wDay, st.wMonth, st.wYear);
	}
	
	DP("-----START LOG-----");
	//MoveToArchive();
}

CPrintLog::~CPrintLog()
{
}

BOOL CPrintLog::DP(char *fmt, ... )
{
	BOOL		LOGGED=TRUE;				// logged	

	FILE		*fp;						// file pointer
	SYSTEMTIME	st;							// system time
	va_list		va;							// arguments vector
	int			count;						// counter

	// open log file
	fp=fopen(logFile, "at");

	if(fp!=NULL)
	{
		// make ap point to 1st unnamed arg
		va_start(va, fmt);

		// get local time
		GetLocalTime(&st);

		// format the string with arguments
		// return -1 if not enough memory
		fprintf(fp, "%02d/%02d/%4d  %02d:%02d:%02d\t", st.wDay, st.wMonth, 
				st.wYear, st.wHour, st.wMinute, st.wSecond);

		count=vfprintf(fp, fmt, va); 
		fprintf(fp, "\n");

		// not enough buffer
		if(count==-1)
		  LOGGED=FALSE;

		// release variable arguments memory
		va_end(va);

		fflush(fp);
		// close file
		fclose(fp);
	
	}
	else
		LOGGED=FALSE;

	return LOGGED;
}

BOOL CPrintLog::ReadINI()
{
	FILE	*fd;
	// get the config filename from registry
	HKEY	m_hKey;

	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, "System\\CurrentControlSet\\Services\\AuthSrv\\Parameters", 0, KEY_EXECUTE, &m_hKey)==ERROR_SUCCESS)
	{
		DWORD size = _MAX_PATH+1;
		DWORD type;
		if (RegQueryValueEx(m_hKey, "ConfigFolder", NULL, &type, (unsigned char *)fname, &size)==ERROR_SUCCESS)
		{
		}
	}

	RegCloseKey(m_hKey);

	//check whether config.ini exists
	fd = fopen(fname, "r");
	if (NULL == fd)
	{
		return FALSE;
	}
	else
	{
		fclose(fd);
		return TRUE;
	}
	
	return TRUE;
}

/**************************************************************************************
**
** Function:  MoveToArchive
**
** Description: 
**
** This function: 
**
** Move out-dated log files to archive directory
**                                
***************************************************************************************/

void CPrintLog::MoveToArchive()
{
	char  cmd[255];	// command

	// move log
	sprintf(cmd, "move /Y \"%s\\*.log\" \"%s\\archive\"", fname, fname);
	system(cmd);
}
