// IASSQL.cpp: implementation of the CIASSQL class.
//
//////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "IASPL.h"
#include "IASSQL.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

extern CPrintLog PL;

CIASSQL::CIASSQL()
{
	hEnv = 0;
	hDBC = 0;
	hStmt = 0;
	connected = FALSE;
}

CIASSQL::~CIASSQL()
{

}

BOOL CIASSQL::connect(char *CONNSTR)
{
	SQLCHAR szConnStr[255] = "";
    SWORD cbConnStr = 0;
	SQLRETURN retcode = 0;
	int counter = 0;

	do{
		/*Allocate environment handle */
		retcode = SQLAllocEnv(&hEnv);
		if (retcode == SQL_SUCCESS || retcode == SQL_SUCCESS_WITH_INFO) {
			/* Allocate connection handle */
			retcode = SQLAllocConnect(hEnv, &hDBC);
			if (retcode == SQL_SUCCESS || retcode == SQL_SUCCESS_WITH_INFO) {
				/* Connect to data source */
				retcode = SQLDriverConnect(hDBC, NULL, (unsigned char *)CONNSTR, strlen(CONNSTR), szConnStr, sizeof(szConnStr), &cbConnStr, SQL_DRIVER_NOPROMPT);
				if (retcode == SQL_SUCCESS || retcode == SQL_SUCCESS_WITH_INFO) {
					/* Allocate statement handle */
					retcode = SQLAllocStmt(hDBC, &hStmt);
					if (retcode == SQL_SUCCESS || retcode == SQL_SUCCESS_WITH_INFO){
						connected = TRUE;
						return TRUE;
					}
				}
			}
		}
		PL.DP("** CIASSQL::connect: Connecting to Database failed");
		counter++;
		if( counter<=3 )
			Sleep(3000);
		PL.DP("** CIASSQL::connect: Re-connecting Database [%d]try", counter);
	}while(counter<=3);

	return FALSE;
}

BOOL CIASSQL::disconnect()
{
	if (hStmt)
		SQLFreeHandle(SQL_HANDLE_STMT, hStmt);

	if (hDBC)
		SQLDisconnect(hDBC);

	if (hDBC)
		SQLFreeHandle(SQL_HANDLE_DBC, hDBC);

	if (hEnv)
		SQLFreeHandle(SQL_HANDLE_ENV, hEnv);

	return TRUE;
}

BOOL CIASSQL::reAllocStmt()
{
	SQLRETURN retcode = 0;

	if( connected ){
		if (hStmt)
			SQLFreeHandle(SQL_HANDLE_STMT, hStmt);

		retcode = SQLAllocStmt(hDBC, &hStmt);
		if (retcode == SQL_SUCCESS || retcode == SQL_SUCCESS_WITH_INFO)
			return TRUE;
	}

	return FALSE;
}
