/* Copyright (c) Patronsoft Limited. All rights reserved. */

#include "StdAfx.h"
#include "IASPL.h"
#include "IASSQL.h"
#include "execSQL.h"

extern CPrintLog PL;
/*********************************************************************************
**
**	3 Aug, 2004 Hans
**
**	Function: IASAuthReadDB
**
**	In: CIASSQL &IASSQL, char *TABLENAME(256), char *username(41)
**	Out: DWORD &accumbw, DWORD &bwcount, DWORD &bwquota, long &bu, long &bd
**
*********************************************************************************/
// 20080425 - Add quota sharing parameters
BOOL IASAuthReadDB(CIASSQL &IASSQL, char *TABLENAME, char *username, long &timeleft,
				   DWORD &accumbw, DWORD &bwcount, DWORD &bwquota,
				   DWORD &accumbwUL, DWORD &bwcountUL, DWORD &bwquotaUL,
				   long &bu, long &bd, char &acl, DWORD &pagenum,
				   DWORD &macmap, char *loginmac, DWORD &ipmap,
				   DWORD &accumbwSha, DWORD &bwcountSha, DWORD &bwquotaSha, 
				   char *iBMsg_glo, char *iBMsg_per)
{
	SQLCHAR szStmt[_MAX_FNAME] = "";
	SDWORD sdwPLen_tleft = 0, sdwPLen_BTUL = 0, sdwPLen_BTDL = 0,
			sdwPLen_bwc = 0, sdwPLen_bwcUL = 0, sdwPLen_acc = 0, sdwPLen_accUL = 0,
			sdwPLen_q = 0, sdwPLen_qUL = 0, sdwPLen_ACL = 0, sdwPLen_PTO = 0;
	SQLUINTEGER ABW = 0, BWQ = 0, ABWUL = 0, BWQUL = 0, PTO = 0;
	SQLINTEGER BWC = 0, BWCUL = 0, tleft = -1, BTUL = 0, BTDL = 0;
	SQLRETURN rc;
	SQLCHAR ACL[41] = "";
	SQLCHAR LOGMAC[16] = "";
	SQLUINTEGER  IPM= 0, MACM=0; 
	SDWORD sdwPLen_IPM = 0, sdwPLen_MACM = 0, sdwPLen_LOGINMAC = 0 ;
	SDWORD sdwPLen_bwcSha = 0, sdwPLen_accSha = 0, sdwPLen_qSha = 0;
	SQLUINTEGER ABWSHA = 0, BWQSHA = 0;
	SQLINTEGER BWCSHA = 0;
	SDWORD sdwPLen_iBMsgGlo = 0, sdwPLen_iBMsgPer = 0;
	SQLCHAR szIBMsg_glo[41] = "";
	SQLCHAR szIBMsg_per[41] = "";

	/* obtain timeleft from database */
	sprintf((char *)szStmt,
		"SELECT timeleft, btul, btdl, bwcount, bwcountUL, accumbw, accumbwUL, bwquota, bwquotaUL, acl, pagenum, macmap, loginmac, ipmap, bwcountSha, accumbwSha, bwquotaSha, iBMsg_glo, iBMsg_per FROM %s WHERE name = '%s';",
		TABLENAME, username);
	SQLPrepare(IASSQL.hStmt, szStmt, strlen((char *)szStmt));
	SQLBindCol(IASSQL.hStmt, 1, SQL_C_SLONG, (PTR)&tleft, sizeof(tleft), &sdwPLen_tleft);
	SQLBindCol(IASSQL.hStmt, 2, SQL_C_SLONG, (PTR)&BTUL, sizeof(BTUL), &sdwPLen_BTUL);
	SQLBindCol(IASSQL.hStmt, 3, SQL_C_SLONG, (PTR)&BTDL, sizeof(BTDL), &sdwPLen_BTDL);
	SQLBindCol(IASSQL.hStmt, 4, SQL_C_SLONG, (PTR)&BWC, sizeof(BWC), &sdwPLen_bwc);
	SQLBindCol(IASSQL.hStmt, 5, SQL_C_SLONG, (PTR)&BWCUL, sizeof(BWCUL), &sdwPLen_bwcUL);
	SQLBindCol(IASSQL.hStmt, 6, SQL_C_ULONG, (PTR)&ABW, sizeof(ABW), &sdwPLen_acc);
	SQLBindCol(IASSQL.hStmt, 7, SQL_C_ULONG, (PTR)&ABWUL, sizeof(ABWUL), &sdwPLen_accUL);
	SQLBindCol(IASSQL.hStmt, 8, SQL_C_ULONG, (PTR)&BWQ, sizeof(BWQ), &sdwPLen_q);
	SQLBindCol(IASSQL.hStmt, 9, SQL_C_ULONG, (PTR)&BWQUL, sizeof(BWQUL), &sdwPLen_qUL);
	SQLBindCol(IASSQL.hStmt, 10, SQL_C_CHAR, (PTR)&ACL, sizeof(ACL), &sdwPLen_ACL);
	SQLBindCol(IASSQL.hStmt, 11, SQL_C_ULONG, (PTR)&PTO, sizeof(PTO), &sdwPLen_PTO);
	SQLBindCol(IASSQL.hStmt, 12, SQL_C_ULONG, (PTR)&MACM, sizeof(IPM), &sdwPLen_MACM);
	SQLBindCol(IASSQL.hStmt, 13, SQL_C_CHAR, (PTR)LOGMAC, sizeof(LOGMAC), &sdwPLen_LOGINMAC);
	SQLBindCol(IASSQL.hStmt, 14, SQL_C_ULONG, (PTR)&IPM, sizeof(IPM), &sdwPLen_IPM);
	SQLBindCol(IASSQL.hStmt, 15, SQL_C_SLONG, (PTR)&BWCSHA, sizeof(BWCSHA), &sdwPLen_bwcSha);
	SQLBindCol(IASSQL.hStmt, 16, SQL_C_ULONG, (PTR)&ABWSHA, sizeof(ABWSHA), &sdwPLen_accSha);
	SQLBindCol(IASSQL.hStmt, 17, SQL_C_ULONG, (PTR)&BWQSHA, sizeof(BWQSHA), &sdwPLen_qSha);
	SQLBindCol(IASSQL.hStmt, 18, SQL_C_CHAR, (PTR)&szIBMsg_glo, sizeof(szIBMsg_glo), &sdwPLen_iBMsgGlo);
	SQLBindCol(IASSQL.hStmt, 19, SQL_C_CHAR, (PTR)&szIBMsg_per, sizeof(szIBMsg_per), &sdwPLen_iBMsgPer);
	
	rc = SQLExecute(IASSQL.hStmt);
	if( SQL_SUCCEEDED(rc) ){
		rc = SQLFetch(IASSQL.hStmt);
		if( SQL_SUCCEEDED(rc) ){
			timeleft = tleft;
			bu = BTUL;
			bd = BTDL;
			accumbw = ABW;
			bwcount = BWC;
			bwquota = BWQ;
			accumbwUL = ABWUL;
			bwcountUL =  BWCUL;
			bwquotaUL = BWQUL;
			accumbwSha = ABWSHA;
			bwcountSha =  BWCSHA;
			bwquotaSha = BWQSHA;
			pagenum = PTO;

			// 20090422 - Set N if ACL is not Y
			if ((char)ACL[0] == 'Y' || (char)ACL[0] == 'y') {
				acl = 'Y';
			} else {
				acl = 'N';
			}

			ipmap = IPM;
			macmap = MACM;
			strcpy(loginmac, (char *)LOGMAC);
			strcpy(iBMsg_glo, (char *)szIBMsg_glo);
			strcpy(iBMsg_per, (char *)szIBMsg_per);
		}else
			PL.DP("** IASAuth: SQLFetch fail[%s]", szStmt);
	}else
		PL.DP("** IASAuth: SQLExecute fail[%s]", szStmt);
	IASSQL.reAllocStmt();

	return TRUE;
}

/*********************************************************************************
**
**	3 Aug, 2004 Hans
**
**	Function: IASLoginWriteDB
**
**	In: CIASSQL &IASSQL, char *TABLENAME(256), char *username(41), char *MACorIP(16)
**	Out:
**
*********************************************************************************/
BOOL IASLoginWriteDB( CIASSQL &IASSQL, char *TABLENAME, char *username, char *MACorIP)
{
	SQLCHAR szStmt[_MAX_FNAME] = "";
	DWORD64 mac_ip_64 = 0;
	BOOL RET = TRUE;
	
	int sizeIp = 0;
	BOOL isIp = FALSE;
	sizeIp = strlen(MACorIP);
	
	// format like Ip (10.20.7.1), find '.' will assume to IP 	
	for (int i =0; i < sizeIp; i++){
		if (MACorIP[i] == '.'){
			isIp = TRUE;
			break;
		}
	}
	
	if( isIp )
		mac_ip_64 = inet_addr(MACorIP);
	else if( strlen(MACorIP)==12 )
		sscanf( MACorIP, "%I64x", &mac_ip_64 );
	else
	{
		PL.DP( "** IASLoginWriteDB: MAC or IP invalid(Calling Station ID)" );
		IASSQL.reAllocStmt();
		RET = FALSE;
	}

	if( RET )
	{
		long curtime = time(NULL);
		sprintf((char *)szStmt, "UPDATE %s SET reserved1 = '%I64u', reserved2 = %u WHERE name = '%s';",
			TABLENAME, mac_ip_64, curtime, username);
		SQLPrepare(IASSQL.hStmt, szStmt, strlen((char *)szStmt));
		if( SQLExecute(IASSQL.hStmt)!=SQL_SUCCESS )
		{
			PL.DP("** IASLoginWriteDB: SQLExecute fail[%s]", szStmt);
			IASSQL.reAllocStmt();
			RET = FALSE;
		}
	}

	IASSQL.reAllocStmt();
	return RET;
}

/*********************************************************************************
**
**	3 Aug, 2004 Hans
**
**	Function: IASLogoutWriteDB
**
**	In: CIASSQL &IASSQL, char *TABLENAME(256), char *username(41), DWORD bwusage,
**		char *szMAC
**	Out:
**
*********************************************************************************/
// 20080425 - Add quota sharing parameters
BOOL IASLogoutWriteDB(CIASSQL &IASSQL, char *TABLENAME, char *LOGTABLENAME, char *username,
					  char *szMAC, DWORD bwusage, DWORD bwusageUL, char *loginmac,
					  DWORD bwusageSha, DWORD accumbw, DWORD accumbwUL, DWORD accumbwSha, 
					  char *iBMsg_glo, char *iBMsg_per)
{
	//SQLCHAR szStmt[_MAX_FNAME] = "";
	SQLCHAR szStmt[_MAX_FNAME*4] = "";
	SQLINTEGER LoginT = 0;
	//SQLUINTEGER ABW = 0, ABWUL = 0;
	SQLINTEGER timel = -1;
	long timeleft = -1;
	SDWORD sdwPLen;
	long diff = 0, logint = 0;
	//unsigned long accumbw = 0, accumbwUL = 0;
	BOOL ret = TRUE;
	SQLRETURN rc = 0;
	//SQLUINTEGER ABWSHA = 0;
	//unsigned long accumbwSha = 0;
	SQLINTEGER BWC = 0, BWCUL = 0, BWCSHA = 0;		// 20080429
	long bwcount = 0, bwcountUL = 0, bwcountSha = 0;	// 20080429

	// Obtain login time
	sprintf((char *)szStmt, "SELECT reserved2 FROM %s WHERE name = '%s';", TABLENAME,
		username);
	SQLPrepare(IASSQL.hStmt, szStmt, strlen((char *)szStmt));
	SQLBindCol(IASSQL.hStmt, 1, SQL_C_SLONG, (PTR)&LoginT, sizeof(LoginT), &sdwPLen);
	rc = SQLExecute(IASSQL.hStmt);
	if( SQL_SUCCEEDED(rc) ){
		rc = SQLFetch(IASSQL.hStmt);
		if( SQL_SUCCEEDED(rc) ){
			logint = LoginT;
		}else{
			PL.DP("** IASLogoutWriteDB: SQLFetch fail[%s]", szStmt);
			PL.DP("** IASLogoutWriteDB: Could not obtain login time");
			ret = FALSE;
		}
	}else{
		PL.DP("** IASLogoutWriteDB: SQLExecute fail[%s]", szStmt);
		PL.DP("** IASLogoutWriteDB: Could not obtain login time");
		ret = FALSE;
	}
	
	IASSQL.reAllocStmt();

	if( !ret )
		return ret;

	// 20080429 - Obtain bandwidth counter flags
	sprintf((char *)szStmt, "SELECT bwcount, bwcountUL, bwcountSha FROM %s WHERE name='%s';", TABLENAME, username);
	SQLPrepare(IASSQL.hStmt, szStmt, strlen((char *)szStmt));
	SQLBindCol(IASSQL.hStmt, 1, SQL_C_SLONG, (PTR)&BWC, sizeof(BWC), &sdwPLen);
	SQLBindCol(IASSQL.hStmt, 2, SQL_C_SLONG, (PTR)&BWCUL, sizeof(BWCUL), &sdwPLen);
	SQLBindCol(IASSQL.hStmt, 3, SQL_C_SLONG, (PTR)&BWCSHA, sizeof(BWCSHA), &sdwPLen);
	rc = SQLExecute(IASSQL.hStmt);
	if (SQL_SUCCEEDED(rc)) {
		rc = SQLFetch(IASSQL.hStmt);
		if (SQL_SUCCEEDED(rc)) {
			bwcount = BWC;
			bwcountUL = BWCUL;
			bwcountSha = BWCSHA;
		} else {
			PL.DP("** IASLogoutWriteDB: SQLFetch fail[%s]", szStmt);
			PL.DP("** IASLogoutWriteDB: Bandwidth Counter Flags assist to zero");
			bwcount = 0;
			bwcountUL = 0;
			bwcountSha = 0;
		}
	} else {
		PL.DP("** IASLogoutWriteDB: SQLExecute fail[%s]", szStmt);
		PL.DP("** IASLogoutWriteDB: Bandwidth Counter Flags assist to zero");
		bwcount = 0;
		bwcountUL = 0;
		bwcountSha = 0;
	}
	IASSQL.reAllocStmt();

	// Obtain Accumulative Bandwidth
	/*
	sprintf((char *)szStmt, "SELECT accumbw, accumbwUL, accumbwSha FROM %s WHERE name = '%s';", TABLENAME,
		username);
	SQLPrepare(IASSQL.hStmt, szStmt, strlen((char *)szStmt));
	SQLBindCol(IASSQL.hStmt, 1, SQL_C_ULONG, (PTR)&ABW, sizeof(ABW), &sdwPLen);
	SQLBindCol(IASSQL.hStmt, 2, SQL_C_ULONG, (PTR)&ABWUL, sizeof(ABWUL), &sdwPLen);
	SQLBindCol(IASSQL.hStmt, 3, SQL_C_ULONG, (PTR)&ABWSHA, sizeof(ABWSHA), &sdwPLen);
	rc = SQLExecute(IASSQL.hStmt);
	if( SQL_SUCCEEDED(rc) ){
		rc = SQLFetch(IASSQL.hStmt);
		if( SQL_SUCCEEDED(rc) ){
			accumbw = ABW;
			accumbwUL = ABWUL;
			accumbwSha = ABWSHA;
		}else{
			PL.DP("** IASLogoutWriteDB: SQLFetch fail[%s]", szStmt);
			PL.DP("** IASLogoutWriteDB: Accummulative Bandwidth assist to zero");
			accumbw = 0;
			accumbwUL = 0;
			accumbwSha = 0;
		}
	}else{
		PL.DP("** IASLogoutWriteDB: SQLExecute fail[%s]", szStmt);
		PL.DP("** IASLogoutWriteDB: Accummulative Bandwidth assist to zero");
		accumbw = 0;
		accumbwUL = 0;
		accumbwSha = 0;
	}
	IASSQL.reAllocStmt();
	*/

	// Obtain time left
	sprintf((char *)szStmt, "SELECT timeleft FROM %s WHERE name = '%s';", TABLENAME,
		username);
	SQLPrepare(IASSQL.hStmt, szStmt, strlen((char *)szStmt));
	SQLBindCol(IASSQL.hStmt, 1, SQL_C_SLONG, (PTR)&timel, sizeof(timel), &sdwPLen);
	rc = SQLExecute(IASSQL.hStmt);
	if( SQL_SUCCEEDED(rc) ){
		rc = SQLFetch(IASSQL.hStmt);
		if( SQL_SUCCEEDED(rc) ){
			timeleft = timel;
		}else{
			PL.DP("** IASLogoutWriteDB: SQLFetch fail[%s]", szStmt);
			PL.DP("** IASLogoutWriteDB: time left assist to unlimit");
		}
	}else{
		PL.DP("** IASLogoutWriteDB: SQLExecute fail[%s]", szStmt);
		PL.DP("** IASLogoutWriteDB: time left assist to unlimit");
	}
	IASSQL.reAllocStmt();

	long curtime = time(NULL);
	long logoutt = 0;
	logoutt = curtime;
	long diffL = curtime - logint;
	
	if (diffL > 60){
		diff = diffL / 60 - 1;
	}
	if( diffL%60>=0 )
		diff += 1;

	// Construct the SQL statment to UPDATE user database
	sprintf((char *)szStmt, "UPDATE %s SET ", TABLENAME);

	strcat( (char*)szStmt, "reserved1 = null" );

	char tmp[21]="";
	if( timeleft>=0 ){
		timeleft = timeleft - diff;
		
		if (timeleft <0)
			timeleft = 0;
		
		sprintf( tmp, ", timeleft = %d", timeleft );
		strcat( (char*)szStmt, tmp );
	}
	else
		strcat( (char*)szStmt, ", timeleft = null" );
	
	ZeroMemory( tmp, 21 );
	sprintf( tmp, ", reserved3 = %d", curtime );
	strcat( (char*)szStmt, tmp );

	// 20080429 - Modify checking conditions of accumulate values
	if (bwcountSha > 0) {
		ZeroMemory(tmp, 21);
		sprintf(tmp, ", accumbwSha = %u", accumbwSha);
		strcat((char *)szStmt, tmp);
	} else {
		if (bwcount != 0) {
			ZeroMemory(tmp, 21);
			sprintf(tmp, ", accumbw = %u", accumbw);
			strcat((char *)szStmt, tmp);
		}
		if (bwcountUL != 0) {
			ZeroMemory(tmp, 21);
			sprintf(tmp, ", accumbwUL = %u", accumbwUL);
			strcat((char *)szStmt, tmp);
		}
	}
	/*if( (accumbw+bwusage)>0 ){
		ZeroMemory( tmp, 21 );
		sprintf( tmp, ", accumbw = %u", accumbw+bwusage );
		strcat( (char*)szStmt, tmp );
	}
	else
		strcat( (char*)szStmt, ", accumbw = null" );

	if( (accumbwUL+bwusageUL)>0 ){
		ZeroMemory( tmp, 21 );
		sprintf( tmp, ", accumbwUL = %u", accumbwUL+bwusageUL );
		strcat( (char*)szStmt, tmp );
	}
	else
		strcat( (char*)szStmt, ", accumbwUL = null" );

	if ((accumbwSha + bwusageSha) > 0) {
		ZeroMemory(tmp, 21);
		sprintf(tmp, ", accumbwSha = %u", accumbwSha+bwusageSha);
		strcat((char*)szStmt, tmp);
	} else {
		strcat((char*)szStmt, ", accumbwSha = null");
	}*/
		
	if( strcmp(loginmac, "")!=0 && strcmp(loginmac, "0")!=0 && loginmac != NULL){
		ZeroMemory( tmp, 21 );
		sprintf( tmp, ", loginmac = %s", loginmac );
		strcat( (char*)szStmt, tmp );
	}
	else
		strcat( (char*)szStmt, ", loginmac = null" );
		
	if( strcmp(iBMsg_glo, "")!=0 && strcmp(iBMsg_glo, "0")!=0 && iBMsg_glo != NULL){
		ZeroMemory( tmp, 21 );
		sprintf( tmp, ", iBMsg_glo = '%s' ", iBMsg_glo );
		strcat( (char*)szStmt, tmp );
	}
	
	if( strcmp(iBMsg_per, "")!=0 && strcmp(iBMsg_per, "0")!=0 && iBMsg_per != NULL){
		ZeroMemory( tmp, 21 );
		sprintf( tmp, ", iBMsg_per = '%s' ", iBMsg_per );
		strcat( (char*)szStmt, tmp );
	}

	strcat( (char*)szStmt, " WHERE name = '" );
	strcat( (char*)szStmt, username );
	strcat( (char*)szStmt, "';" );

	// 20080429 - Show log also for successful case
	SQLPrepare(IASSQL.hStmt, szStmt, strlen((char *)szStmt));
	rc = SQLExecute(IASSQL.hStmt);
	if (!SQL_SUCCEEDED(rc)) {
		PL.DP("** IASLogoutWriteDB: SQLExecute fail[%s]", szStmt);
	} else {
		PL.DP("** IASLogoutWriteDB: SQLExecute update OK [%s]", szStmt);
	}
	
	IASSQL.reAllocStmt();

	// 20090422 - Remove the ending new line characters
	char t1[41]="", t2[41]="";
	strcpy( t1, ctime(&logint) );
	if (strlen(t1) > 40) {
		t1[40] = '\0';
	} else {
		t1[strlen(t1)-1] = '\0';
	}
	strcpy( t2, ctime(&curtime) );
	if (strlen(t2) > 40) {
		t2[40] = '\0';
	} else {
		t2[strlen(t2)-1] = '\0';
	}
	
	PL.DP("** IASLogoutWriteDB: curtime[%d]logint [%d] diffL[%d] diff[%d]logoutt[%d]", curtime,logint,diffL,diff,logoutt);
		
	
	// 20080429 - Increase length
	// Construct the SQL statment to INSERT userlog database
	//ZeroMemory( szStmt, _MAX_FNAME );
	ZeroMemory(szStmt, _MAX_FNAME*4);
	sprintf((char *)szStmt,
		"INSERT INTO %s (NAME, LOGINTIME, LOGOUTTIME, DURATION, IPORMAC, RESERVED10, RESERVED11, bwusage, bwusageUL, bwusageSha) VALUES ",
		LOGTABLENAME );

	// 20080429 - Modify for quota sharing part
	//char value[256] = "";
	char value[_MAX_FNAME*4] = "";
	if (bwcountSha > 0) {
		if (bwusageSha > 0) {
			sprintf(value, "('%s', '%s', '%s', %d, '%s', %d, %d, null, null, %u)",
				username, t1, t2, diff, szMAC, logint, curtime, bwusageSha);
		} else {
			sprintf(value, "('%s', '%s', '%s', %d, '%s', %d, %d, null, null, 0)",
				username, t1, t2, diff, szMAC, logint, curtime);
		}
	} else if (bwcount != 0 && bwcountUL != 0) {
		if (bwusage > 0 && bwusageUL > 0) {
			sprintf(value, "('%s', '%s', '%s', %d, '%s', %d, %d, %u, %u, null)",
				username, t1, t2, diff, szMAC, logint, curtime, bwusage, bwusageUL);
		} else if (bwusage > 0) {
			if (bwcountUL == -1) {
				sprintf(value, "('%s', '%s', '%s', %d, '%s', %d, %d, %u, null, null)",
					username, t1, t2, diff, szMAC, logint, curtime, bwusage);
			} else {
				sprintf(value, "('%s', '%s', '%s', %d, '%s', %d, %d, %u, 0, null)",
					username, t1, t2, diff, szMAC, logint, curtime, bwusage);
			}
		} else if (bwusageUL > 0) {
			if (bwcount == -1) {
				sprintf(value, "('%s', '%s', '%s', %d, '%s', %d, %d, null, %u, null)",
					username, t1, t2, diff, szMAC, logint, curtime, bwusageUL);
			} else {
				sprintf(value, "('%s', '%s', '%s', %d, '%s', %d, %d, 0, %u, null)",
					username, t1, t2, diff, szMAC, logint, curtime, bwusageUL);
			}
		} else {
			sprintf(value, "('%s', '%s', '%s', %d, '%s', %d, %d, null, null, null)",
				username, t1, t2, diff, szMAC, logint, curtime);
		}
	} else if (bwcount != 0) {
		if (bwusage > 0) {
			sprintf(value, "('%s', '%s', '%s', %d, '%s', %d, %d, %u, null, null)",
				username, t1, t2, diff, szMAC, logint, curtime, bwusage);
		} else {
			sprintf(value, "('%s', '%s', '%s', %d, '%s', %d, %d, 0, null, null)",
				username, t1, t2, diff, szMAC, logint, curtime);
		}
	} else if (bwcountUL != 0) {
		if (bwusageUL > 0) {
			sprintf(value, "('%s', '%s', '%s', %d, '%s', %d, %d, null, %u, null)",
				username, t1, t2, diff, szMAC, logint, curtime, bwusageUL);
		} else {
			sprintf(value, "('%s', '%s', '%s', %d, '%s', %d, %d, null, 0, null)",
				username, t1, t2, diff, szMAC, logint, curtime);
		}
	} else {
		sprintf(value, "('%s', '%s', '%s', %d, '%s', %d, %d, null, null, null)",
			username, t1, t2, diff, szMAC, logint, curtime);
	}
	/*
	if (bwusage == 0 && bwusageUL == 0 && bwusageSha == 0) {
		sprintf(value, "('%s', '%s', '%s', %d, '%s', %d, %d, null, null, null)",
			username, t1, t2, diff, szMAC, logint, curtime);
	} else if (bwusage == 0 && bwusageUL > 0 && bwusageSha == 0) {
		sprintf(value, "('%s', '%s', '%s', %d, '%s', %d, %d, null, %u, null)",
			username, t1, t2, diff, szMAC, logint, curtime, bwusageUL);
	} else if (bwusage > 0 && bwusageUL == 0 && bwusageSha == 0) {
		sprintf(value, "('%s', '%s', '%s', %d, '%s', %d, %d, %u, null, null)",
			username, t1, t2, diff, szMAC, logint, curtime, bwusage);
	} else if (bwusage == 0 && bwusageUL == 0 && bwusageSha > 0) {
		sprintf(value, "('%s', '%s', '%s', %d, '%s', %d, %d, null, null, %u)",
			username, t1, t2, diff, szMAC, logint, curtime, bwusageSha);
	} else {
		sprintf(value, "('%s', '%s', '%s', %d, '%s', %d, %d, %u, %u, null)",
			username, t1, t2, diff, szMAC, logint, curtime, bwusage, bwusageUL);
	}
	*/

	// 20080429 - Increase length
	if( (strlen(value)+strlen((char*)szStmt))< _MAX_FNAME*4 )
		strcat( (char *)szStmt, value );
	else
		PL.DP( "** IASLogoutWriteDB: szStmt exceed %d length", _MAX_FNAME*4);

	SQLPrepare(IASSQL.hStmt, szStmt, strlen((char *)szStmt));
	rc = SQLExecute(IASSQL.hStmt);
	if( !SQL_SUCCEEDED(rc) ){
		PL.DP("** IASLogoutWriteDB: SQLExecute fail[%s]", szStmt);
	}
	IASSQL.reAllocStmt();
	PL.DP("** IASLogoutWriteDB: SQLExecute [%s]", szStmt);

	return TRUE;
}
